# Find presentations that aren't publically visible.

import os
import sys
import time

import komxx
import kompolicy
import prefetcher

BODY = """Det hr brevet skickas ut automatiskt till ett femtiotal personer, som
har det gemensamt att era presentationer inte r publika.  Jag har
inte lst din hemliga presentation.

Eftersom din presentation inte har ngot publikt mte som mottagare r
den inte r lsbar av alla.  Om du anvnder elispklienten kan du lgga
till en ppen mottagare med hjlp av kommandot "a Addera mottagare".
Mtet "Presentation (av nya) medlemmar" eller "allmnt lsbart" kan
var lmpliga mottagare.

Om det r avsiktligt du gjort s hr, s fr du naturligtvis ha det
s.  Men eftersom du har gjort dig besvret att skriva en presentation
antar jag att din avsikt faktiskt var att den skulle vara lsbar fr
allmnheten.

Jag r nyfiken p varfr s mnga presentationer inte r allmnt
lsbara.  r det en bugg i ngon klient?  r det en ny trend jag inte
begriper?  Stilla grna min nyfikenhet om du har lust."""


class applet(kompolicy.tty_io, kompolicy.login):
    def __init__(self, host, port):
        print "Connecting..."
        self.session = komxx.new_session(host, port, "hidden-presentations.py",
                                         "$Revision: 1.1 $")
        print "Connected."
        self.login()
        self.maybe_enable()
        targets = self.session.lookup_z_name("", 1, 0)
        targets = prefetcher.prefetch_confno_presentation(self.session,
                                                          targets)
        for target in targets:
            c = self.session.conf(target.conf_no())
            if c.presentation() != 0:
                t = self.session.text(c.presentation())
                if t.exists():
                    visible = 0
                    for r in t.recipients():
                        rc = self.session.conf(r.recipient())
                        if rc.exists():
                            ct = rc.type()
                            if not (ct.is_protected() or ct.is_secret()):
                                visible = 1
                                break
                    if not visible:
                        print "%5d %9d %s" % (target.conf_no(),
                                              c.presentation(),
                                              c.name())
                        if 0:
                            t = self.session.create_text("Din presentation r osynlig",
                                                         BODY,
                                                         [target.conf_no(), 35],
                                                         [],
                                                         [c.presentation()],
                                                         [])
                            print "Skapat ppekande", t
                else:
                    print "%5d %9s %s" % (target.conf_no(), "-", c.name())

if __name__ == "__main__":
    applet("kom.lysator.liu.se", "4894")
