# $Id: language.py,v 1.74 2000/10/22 19:44:56 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string
import time
import komhtml
import log

# Set by sc and lm.  This module uses toolbar.at_top(),
# toolbar.at_bottom() and similar methods to extract the tool bar.
toolbar = None

TEXT_FORMAT = """%(creation_date)s (text %(text_no)d) %(author)s<br>
%(recipients)s%(uplinks)s%(marks)s
rende: <b>%(subject)s</b>
<hr noshade>
%(body)s
<hr noshade>
%(footnotes)s%(comments)s
"""

TEXT_FORMAT_JULY_1997 = """\
<table cellpadding=3 cellspacing=0 border=0 width="100%%">
<tr bgcolor="#ccffff">
 <td valign=top>Frfattare: %(author)s</td>
 <td align=right>(%(creation_date)s)</td>
</tr>
<tr bgcolor="#ccffff">
 <td>rende: <b>%(subject)s</b></td>
 <td align=right>(Text: %(text_no)d)</td>
</tr>
<tr bgcolor="#ccffff">
 <td colspan=2>%(uplinks)s%(recipients)s%(marks)s</td>
</tr>
<tr bgcolor="#ffffff">
 <td colspan=2><hr></td>
</tr>
<tr bgcolor="#FFFFFF">
 <td colspan=2>%(body)s</td>
</tr>
<tr bgcolor="#ffffff">
 <td colspan=2><hr></td>
</tr>
<tr bgcolor="#ccffff">
 <td colspan=2>%(footnotes)s%(comments)s</td>
</tr>
</table>
"""

CONVERSION_FORMAT = """Konvertering av text:<br>
<input type="radio" name="conversion"
    value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
    value="none" %(select_none)s>ingen<br>"""

WRITE_COMMENT_FORMAT = """Kommentera text %(parent_link)s %(parent_author)s
%(form)s
"""

WRITE_PERSONAL_ANSWER_FORMAT = """Skicka personligt svar till
%(parent_link)s %(parent_author)s
%(form)s
"""

WRITE_TEXT_FORMAT = """Skriva ett nytt inlgg i %(conf-name)s.
%(form)s
"""

WRITE_PRESENTATION_FORMAT = """Skriva en ny presentation av %(conf-name)s.
%(form)s
"""

WRITE_TEXT_FORM = """

<p><form action="submit_text" method="get">
<input type="hidden" name="known_comments" value="%(known_comments)s">
%(conversion)s
%(presentations)s
%(recipients)s
%(comments)s

<p><input type="submit" value="%(submit_text)s">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70" wrap="hard">%(body)s</textarea>

<p><input type="submit" value="%(submit_text)s">
</form>
%(comments_inline)s
"""

COMMENTING_FORM = """

<p>%(lead)s<br>
<form><textarea name="body" rows="10" cols="70" wrap="hard"
>%(body)s</textarea>
"""

REVIEW_TEXTS_FORM = """\

<p>
<form action="review_texts2" method="get">
terse texter i mtet %(confname)s.
<p>
Antal inlgg:
<input type="text" name="num_texts" size=8><br>
<p>
<input type="submit" value="ndra antal olsta">
<input type="hidden" name="conf_no" value="%(conf_no)d">
</form>
"""


MOVE_TEXT_FORM="""
Flytta text nummer %(text-no)s.

%(error)s

<p>
<form action="move_text2" method="get">
<b>Kryssa i de mottagare du vill ta bort:<b><br>
<table border=1>
%(recipients)s
</table>


<p>
<b>Vilket mte skall texten flyttas till?</b><br>
<input type="text" name="new_recipient" size=50 value=""><br>
<input type="hidden" name="text_no" value="%(text-no)s"><br>
<input type="submit" value="Flytta texten">
</form>
"""


SET_UNREAD_FORM = """
<form action="set_unread" method="get">
Hr kan du ndra antalet olsta texter i %(name_nolink)s.  Du kan
vlja att bara lsa inlgg som skrivits de senaste dagarna, eller att
bara lsa de senaste inlggen.
<p>
Antal inlgg: <input type="text" name="unread_texts" size=8><br>
Antal dagar: <input type="text" name="unread_days" size=8>
<input type="submit" value="ndra antal olsta">
<input type="hidden" name="conf_no" value="%(conf_no)d">
</form>
"""

CONFIGURATION_FORM = """

P den hr sidan kan du stlla in hur du vill att WWW-kom ska fungera.
Med tiden kommer fler och fler saker att g att pverka hr.  De
instllningar du gr sparas mellan sessionerna.

<form action="submit_configuration" method="get">

<h3>Bakgrundsfrg</h3>

Vill du att WWW-kom ska stta bakgrundsfrg p sidorna?<br>

<input type="radio" name="color" value="default" %(color-default)s>
Ja, anvnd bakgrundsfrg fr att ka tydligheten.<br>

<input type="radio" name="color" value="none" %(color-none)s>
Nej, lt min browser bestmma frgen.<br>

<h3>Konvertering swascii -> ISO 8859-1</h3>

De svenska tecknen "", "" och "" kan vara svra att mata in frn
viss utrustning.  Om du har lttare att mata in "}", "{" och "|" s
kan WWW-kom konvertera den text du skriver t dig nr du skapar
inlgg.  Tnk p att om du slr p den hr konverteringen s blir det
omjligt fr dig att skriva fljande tecken: "}{|][\\".

<p>Vill du att WWW-kom ska konvertera texter du skriver t dig?<br>

<input type="radio" name="entry-conversion" value="off" %(ec-off)s>
Nej, konvertera inte.<br>

<input type="radio" name="entry-conversion" value="ask-off" %(ec-ask-off)s>
Konvertera inte, men ge mjlighet att sl p konvertering varje gng
en text skrivs.<br>

<input type="radio" name="entry-conversion" value="ask-on" %(ec-ask-on)s>
Konvertera, men ge mjlighet att sl av konvertering varje gng
en text skrivs.<br>

<input type="radio" name="entry-conversion" value="on" %(ec-on)s>
Ja, konvertera alltid.

<h3>Utseende</h3>

Det finns ngra olika utseenden du kan vlja mellan.
Defaultalternativet krver att din browser kan hantera tabeller.  De
andra alternativen r inte lika krvande.

<p>WWW-kom kan ha fyra olika utseenden.  Vilket tycker du bst om?<br>

<input type="radio" name="looknfeel" value="default" %(lnf-default-checked)s>
Navigeringsverktyg till vnster, rubrik verst, och defaultknapp
lngst till hger.<br>

<input type="radio" name="looknfeel" value="traditional"
%(lnf-traditional-checked)s>Navigeringslist verst p sidan med enkla
knappar med text p, som ser ut s hr: %(lnf-default-demo)s<br>

<input type="radio" name="looknfeel" value="textonly" %(lnf-text-checked)s>
Navigeringslist med enbart text.  Motsvarande knapp ser ut s hr:
%(lnf-text-demo)s<br>

<input type="radio" name="looknfeel" value="sillyicons" %(lnf-silly-checked)s>
Navigeringslist med frgglada, men ack s svrbegripliga, ikoner:
%(lnf-silly-demo)s<br>

<h3>Begrnsa antal mten</h3>

Nr du vljer %(home-demo)s frn navigerinslisten visas normalt en
versiktssida med alla mten dr du har olsta texter.  Om det r
mnga mten kan det ta tid att f fram hela sidan.  Hr kan du
stta en maxstorlek p hur stor listan ska f vara.  Om det egentligen
finns fler mten med nyheter visas en text lngst ner som berttar
det.  Allt eftersom du lser inlggen kommer nya mten att visas i
listningen, tills du har frre olsta n den grns du stter hr.

<p>Om fltet r blankt eller "0" kommer det inte att finnas ngon
begrnsning.<br>

Grns: <input type="text" name="home-max-confs"
	size="10" value=\"%(home-max-confs)s">

<h3>Klickbara frfattare</h3>

Nr du vljer %(conf-demo)s frn navigerinslisten visas en
versiktssida med de olsta texter som finns i mtet.  Om man klickar
p textnumret eller renderaden fr en viss text fr man se den
texten.  Nr "klickbara frfattare" r p slaget kan man dessutom
klicka p frfattarna p den sidan.  Om man gr det fr man upp en
statussida fr frfattaren.<br>

<input type="radio" name="conf-authors-linked" value="off" %(cal-off-checked)s>
Ej klickbara frfattare.
<input type="radio" name="conf-authors-linked" value="on" %(cal-on-checked)s>
Klickbara frfattare.

<h3>Nedflyttade renderader</h3>

Ofta har en kommentar till ett inlgg samma rende som inlgget den
kommenterar.  P textversiktssidan skrivs normalt bara rendet fr
den frsta texten med samma rende ut, och resten erstts med "--" som
ett sorts nedflyttningstecken.<br>

<input type="radio" name="conf-compact-duplicates" value="on" %(ccd-on-checked)s>
Nedflyttningstecken.
<input type="radio" name="conf-compact-duplicates" value="off" %(ccd-off-checked)s>
terupprepa renderaden.

<p><input type="submit" value="Spara instllningarna">
</form>
"""

WRITE_TEXT_NEW_COMMENTS = """\
Sedan du brjade frfatta din kommentar har det skapats minst en
ny kommentar.  gna igenom de nya texterna nedan.  Om du fortfarande
tycker att din kommentar r relevant kan du klicka p
"Skapa kommentaren"-knappen (lngst ner p sidan) fr att skicka in
texten igen.  Om du mrker att ngon annan redan har sagt det du hade
tnkt sga r det kanske ingen strre vits med att du upprepar samma
sak en gng till.  I s fall kan du g tillbaks och fortstta lsa.
<p>

<hr noshade><blockquote>
%(new_texts)s
</blockquote><hr>
%(form)s
"""

KILLED = """\
Din sessionshanterare r nu avslutad.  Du r utloggad ur LysKOM.
Observera dock att din WWW-klient troligtvis fortfarande innehller
ditt LysKOM-anvndarnamn och lsenord.  Fr att skerstlla att
ingen obehrigt anvnder LysKOM i ditt namn br du starta om din
WWW-klient innan du lmnar datorn.

<p>Du kan starta en ny session genom att vlja ngot av alternativen ovan.
"""

SELECT_CONF_FORM = """\
<form action="submit_select_conf" method=get>
<b>Namn:</b> <input type="text" name="conf_name" size=50>
<input type="submit" value="Sk">
<p>
<b>Vad vill du ska efter?</b><br>
<input type="radio" name="domain" value="conf" checked>Enbart mten<br>
<input type="radio" name="domain" value="pers">Enbart personer<br>
<input type="radio" name="domain" value="both">Bde personer och mten<br>
</form>

<p>I rutan efter "Namn" kan du fylla i ett mtes- eller personnamn.
Du kan frkorta namnet genom att utelmna ord p slutet, och genom att
utelmna bokstver p slutet i ord.  Om mer n ett mte matchar det
frkortade mtesnamnet du angivit kommer du att f upp en lista med
dem, dr du kan vlja rtt.

<p>Om du lmnar rutan tom kommer alla mten att returneras.  Det kan
ta ett bra tag.

<p>Du kan vlja om du vill ska bland mten, personer eller bde och.
"""


CREATE_CONF_FORM = """\

Du hller p att skapa ett nytt mte.  Du br ge mtet ett s
beskrivande namn som mjligt.  Delar av namnet som skrivs inom
parentes kommer inte att matchas nr man slr upp mtesnamnet, s det
kan vara lmpligt att stta ord som "fr" och "att" inom parentes.
Det frsta ordet br vara beskrivande fr mtet.

<form action="submit_create_conf" method="get">
<b>Namn:</b> <input type="text" name="conf_name" size=50><br>

<b>Ska mtet vara ppet?</b><br>
<input type="radio" name="prot" value="0" checked
>Ja, vem som helst fr bli medlem.<br>
<input type="radio" name="prot" value="1"
>Nej, organisatren slpper in nya medlemmar.<p>

<b>Ska man f kommentera inlgg?</b><br>
<input type="radio" name="orig" value="0" checked
>Ja.<br>
<input type="radio" name="orig" value="1"
>Nej.  Kommentarer skickas till vermtet.<p>

<b>Ska mtet vara hemligt?</b><br>
<input type="radio" name="secr" value="1" 
>Ja.  Bara medlemmar fr se mtet.<br>
<input type="radio" name="secr" value="0" checked
>Nej.<p>

<input type="submit" value="Skapa mtet">
</form>

"""

ADMIN_CONF_FORM = """\

Administration av mte %(conf-no)s: %(conf-name)s

<form action="submit_admin_conf" method="get">
<b>Nytt namn:</b><br>
<input type="text" name="conf_name" size=50 value="%(conf-name)s"><br>
<input type="hidden" name="conf_no" value="%(conf-no)s"><br>

<b>Ska mtet vara ppet eller slutet?</b><br>
<input type="radio" name="prot" value="0" %(unprotected-checked)s>
  ppet - vem som helst fr bli medlem.<br>
<input type="radio" name="prot" value="1" %(protected-checked)s>
  Slutet - organisatren slpper in nya medlemmar.<p>

<b>Ska man f kommentera inlgg?</b><br>
<input type="radio" name="orig" value="0" %(non-orig-checked)s>
  Ja.<br>
<input type="radio" name="orig" value="1" %(orig-checked)s>
  Nej.  Kommentarer skickas till vermtet.<p>

<b>Ska mtet vara hemligt?</b><br>
<input type="radio" name="secr" value="1" %(secret-checked)s>
  Ja.  Bara medlemmar fr se mtet.<br>
<input type="radio" name="secr" value="0" %(nonsecret-checked)s>
  Nej, vem som helst kan se mtet.<p>

<input type="submit" value="ndra mtet">
</form>

<hr>
<form action="submit_admin_members" method="get">

<input type="hidden" name="conf_no" value="%(conf-no)s"><br>
<input type="submit" value="ndra medlemmar">

<p>
<b>Lgg till fljande person som medlem i mtet:</b><br>
<input type="text" name="new_member" size=50"><br>
<p>

<b>Uteslut fljande medlemmar i mtet:</b><br>
<table border=1>
%(members)s
</table>
<p>

<input type="submit" value="ndra medlemmar">
</form>

"""

SUBMIT_ADMIN_MEMBERS_FORM = """\

Administration av medlemmar i mte %(conf-no)s: (%(conf-name)s)

<p>
<b>Fljande person r nu medlem i mtet:</b><br>
%(new-member)s
<p>

<b>fljande medlemmar r nu uteslutna ur mtet:</b><br>
%(del-members)s
<p>


"""

CONF = """\
%(set-unread-form)s
%(unread)s
%(truncated)s
<p>
%(estim-unread)s

"""


CONF_STAT = """\
%(become-member)s
%(goto-conference)s
%(set-unread-form)s
%(estimated-unread)s
%(motd)s
%(presentation)s
%(change-presentation)s
%(disjoin-conference)s
%(info-fields)s
"""

CREATE_USER_FORM = """\

Du hller p att skapa en ny anvndaridentitet.  Fr att skapa maximal
klarhet, br du lta namnet I din organisation ing; du kan till
exempel ange <emph>Eskil Block, FOA</emph>.  Om du vill s kan du
senare byta namn p din anvndaridentitet om du t ex skulle byta
organisation.

<p>
<hrule>
<form action="submit_create_user" method=get>
Anvndarens namn: <input type="text" name="username" size=50><br>
Ange nskat lsenord: <input type="password" name="password" size=10><br>
Lsen en gng till: <input type="password" name="passcheck" size=10>
(fr kontroll)
<p>
<input type="submit" value="Skapa anvndaren">
<input type="reset" value="Tm formulr">
</form>


"""


JULY_1997_PAGE = """\
<html><head><title>%(title)s</title></head>
%(body_tag)s
<table cellpadding=0 cellspacing=0 border=0>
 <tr>
  %(toolbar)s
 <td width=12><img src="/fill.gif" alt=""></td>
 <td valign=top width="100%%">
  <table width="100%%" cellpadding=3 cellspacing=0 border=0>
   <tr%(headcolor)s>
    <td width="100%%"><font size=+2>%(position)s</font></td>
    <td valign=top rowspan=2 align=right>%(default)s</td>
   </tr>
   <tr%(headcolor)s>
    <td>%(subtitle)s</td>
   </tr>
   <tr><td colspan=2><br></td></tr>
   <tr%(white)s>
    <td colspan=2>
     %(header)s%(body)s%(textops)s
    </td>
   </tr>
  </table>
 </td>
 </tr>
</table>
<hr noshade>
<table>
 <tr>
  <td>%(siglogo)s%(wwwlogo)s</td>
  <td><font size=-1>Sidan genererad %(time)s av WWW-kom.</font>
      <br>WWW-kom. Copyright  1996-1997 Signum Support AB.</td>
 </tr>
</table>
</body></html>"""

class pages:
    def __init__(self):
	self.use_color = 1
	self.july_1997_layout = 1

    def page(self, title, header, body, position=None, subtitle="&nbsp;"):
	global toolbar

	if self.july_1997_layout:
	    if self.use_color:
		body_tag = '<body bgcolor="#fafad7" text="#000000" ' \
			   'link="#0000ee" vlink="551a8b" alink="ff0000">'
		headcolor=' bgcolor="#CCCCFF"'
		white    =' bgcolor="#ffffff"'
	    else:
		body_tag = "<body>"
		headcolor = ""
		white = ""

	    left_toolbar = toolbar.table_element()
	    right_toolbar = toolbar.default_element()

	    # "position" is the text to print in the head as a navigation help.
	    # "title" appears in the title.
	    # "header" should appear on the page, but not if it is
	    # equal to the position.
	    if position == None:
		position = title
	    if header == position:
		header = ""
	    elif header != "":
		header = "<h2>" + header + "</h2>"

	    return JULY_1997_PAGE % {
		"title": self.title(title),
		"position": position,
		"header": header,
		"subtitle": subtitle,
		"toolbar": left_toolbar,
		"default": right_toolbar,
		"textops": toolbar.text_ops(),
		"body_tag": body_tag,
		"white":white,
		"body": body,
		"headcolor": headcolor,
		"time":self.format_date(time.localtime(time.time())),
		"siglogo":komhtml.icon("signum", "Signum Support AB",
				       "http://www.signum.se/"),
		"wwwlogo":komhtml.icon("wwwkom", "WWW-koms hemsida", "/"),
		}
	    
	if toolbar:
	    top_tool = toolbar.at_top()
	    bot_tool = toolbar.at_bottom()
	    toolbar = None
	else:
	    top_tool = ""
	    bot_tool = ""
	body_tag = "<body>\n"
	if self.use_color:
	    body_tag = ('<body bgcolor="#ffffff" text="#000000"'
			+ ' link="#0000ee" vlink="551a8b" alink="ff0000">\n')
	if header != "":
	    header = "<h2>" + header + "</h2>\n\n"
	return ("<html><head><title>" + self.title(title)
		+ "</title></head>\n"
		+ body_tag
		+ top_tool + "\n"
		+ header + body + bot_tool + "\n\n"
		+ self.stdfoot() + "</body></html>")

    def color_mode(self, mode):
	if mode == "none":
	    self.use_color = 0
	elif mode == "default":
	    self.use_color = 1
	# Silently ignore bad modes.

    def layout_mode(self, mode):
	if mode == "July 1997":
	    self.july_1997_layout = 1
	elif mode == "traditional":
	    self.july_1997_layout = 0
	# Silently ignore bad modes.

    def help(self, key):
	(a, b, c) = self.helpmap[key]
	demo = {
	    "home-demo":komhtml.iconref("home", self.alt_home()),
	    "help-demo":komhtml.iconref("help", self.alt_help()),
	    "conf-demo":komhtml.iconref("selconf", self.alt_conf()),
	    "next-conf-demo":komhtml.iconref("next-conf",
					     self.alt_next_conf("")),
	    "next-text-demo":komhtml.iconref("next-text",
					     self.alt_next_text(0)),
	    "next-comment-demo":komhtml.iconref("next-comment",
						self.alt_next_comment(0)),
	    "next-footnote-demo":komhtml.iconref("next-footnote",
						 self.alt_next_footnote(0)),
	    "time-demo":komhtml.iconref("time", self.alt_see_time()),
	    "answer-demo":komhtml.iconref("answer", self.alt_answer()),
	    "comment-demo":komhtml.iconref("comment", self.alt_comment()),
	    "write-demo":komhtml.iconref("write", self.alt_write_text()),
	    "unformatted-demo":komhtml.iconref("unformatted",
					       self.alt_unformatted()),
	    "formatted-demo":komhtml.iconref("formatted",
					     self.alt_formatted()),
	    "board-demo":komhtml.iconref("board", self.alt_conf()),
	    "home-demo":komhtml.iconref("home", self.alt_home()),
	    "selconf-demo":komhtml.iconref("selconf", self.alt_select_conf()),
	    "create-conf-demo":komhtml.iconref("create-conf",
					       self.alt_create_conf()),
	    "config-demo":komhtml.iconref("config", self.alt_config()),
	    "exit-demo":komhtml.iconref("exit", self.alt_kill())
	    }
		
	return self.page(a, b, c % demo)



SV_HELPMAP = {
    "home":

    ("Hjlp fr mtesversikt", "Mtesversikt", """

    Den hr versiktssidan r normalt den frsta sidan man kommer till
    nr man loggar in.  Man kan nr som helst tervnda till den genom
    att klicka p %(home-demo)s i <a
    href="toolbar">navigeringslisten</a>.

    <p>Listan visar en uppskattning av antalet olsta texter och
    namnet p mtet.  Det kan hnda att antalet texter inte stmmer
    exakt.  Texter som har mer n en mottagare rknas dessutom i alla
    mten de har som mottagare, s det kan hnda att totalsumman r
    betydligt strre n det verkliga antalet olsta inlgg.

    <p>Fr tillfllet visas mtena i stort sett i slumpmssig ordning.
    P sikt finns planer p att fixa s att mtena alltid listas i en
    ordning som du sjlv kan stlla in.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "login":

    ("Hjlp fr inloggningssidan", "Inloggning", """

    Nr du loggar in kommer du i princip till samma sida som <a
    href="home">mtesversikten</a>.  Ls om dess hjlptext i stllet.

    """),

    "toolbar":

    ("Hjlp fr navigeringslisten", "Navigeringslisten", """

    verst p varje sida finns en navigeringslist.  Exakt vad den
    innehller varierar frn sida till sida eftersom man bara kan gra
    vissa saker i vissa lgen.  En del kommandon som visserligen r
    anvndbara jmnt, men som man sllan anvnder, kan bara kommas t
    frn versiktssidan.
	      
    <p>Hr r en kort frklaring av alla de knappar som frekommer i
    navigeringslisten.  Ikonerna r lnkade till hjlpsidan fr den
    sida du normalt kommer till nr du anvnder ikonen.

    <dl>

    <dt><a href="conf">%(next-conf-demo)s</a>

    <dd>G till nsta mte.  Den hr ikonen visas nr du inte har
    ngra olsta texter kvar i ditt nuvarande mte, eller om du precis
    har loggat in och inte r nrvarande i ngot mte.

    <dt><a href="text">%(next-text-demo)s</a>

    <dd>Visa nsta olsta text i aktuellt mte.

    <dt><a href="text">%(next-comment-demo)s</a>

    <dd>Visa nsta kommentar.  Nr du lser en text kommer WWW-kom
    ihg alla kommentarer och fotnoter till texten, och ser till att
    du fr lsa dem innan du gr vidare med texter som hr till andra
    kommentarskedjor.

    <dt><a href="text">%(next-footnote-demo)s</a>

    <dd>Visa nsta fotnot.  Fotnoter till inlgg visas fre
    kommentarer, ven om fotnoten r skriven efter kommentarerna.

    <dt><a href="time">%(time-demo)s</a>

    <dd>Bertta vad klockan r.  Det hr alternativet dyker upp nr du
    har lst slut p alla texter.  Egentligen r det kanske inte s
    meningsfullt, men ngot default-kommando ska det ju finnas, och
    traditionellt har KOM-system ofta visat tiden nr det inte funnits
    ngot annat att gra.

    <dt><a href="comment">%(comment-demo)s</a>

    <dd>Kommentera inlgget.  Du fr upp ett formulr dr du kan
    skriva in din text.  Den text du skapar kommer att vara en
    kommentar till texten som just nu visas.

    <dt><a href="answer">%(answer-demo)s</a>

    <dd>Svara personligt p et tinlgg.  Du fr upp ett formulr dr
    du kan skriva in din text.  Den text du skapar kommer att vara en
    kommentar till texten som just nu visas, och bara du och
    frfattaren till texten som visas kommer att kunna se den.

    <dt><a href="write_text">%(write-demo)s</a>

    <dd>Skriva ett inlgg i mtet.  Du fr upp ett formulr dr du kan
    skriva in din text.

    <dt><a href="text">%(unformatted-demo)s</a>

    <dd>LysKOM r i grund och botten textbaserat.  Inlggen
    formatteras av frfattaren nr han skriver dem.  De flesta andra
    klienter till LysKOM visar inlgg med en fixbreddsfont.  WWW-kom
    frsker dremot formattera om texten s att den ska passa i en
    Web-browser.  Ibland gissar den fel p vad frfattaren har menat.
    Genom att klicka p den hr ikonen formatteras texen om s att den
    visas med en fixbreddsfont p samma stt som LysKOM-anvndare som
    anvnder andra klienter ser den.

    <dt><a href="text">%(formatted-demo)s</a>

    <dd>Anvnd heuristiken som det talas om ovan fr att visa inlgget
    p ett snyggare stt.

    <dt><a href="conf">%(board-demo)s</a>

    <dd>Visa en versikt ver de olsta texter som finns i nuvarande
    mte.

    <dt><a href="home">%(home-demo)s</a>

    <dd>Visa en versikt ver de mten dr du har olsta inlgg.

    <dt><a href="select_conf_form">%(selconf-demo)s</a>

    <dd>Ta fram ett formulr dr man kan leta reda p ett mte genom
    att ska p mtesnamn.

    <dt><a href="create_conf_form">%(create-conf-demo)s</a>

    <dd>Ta fram ett formulr dr man kan skapa ett mte.

    <dt><a href="configuration">%(config-demo)s</a>

    <dd>Gr personliga instllningar av WWW-koms utseende och
    beteende.

    <dt><a href="kill">%(exit-demo)s</a>

    <dd>Avsluta sessionen.

    <dt>%(help-demo)s

    <dd>F upp en hjlpsida som beskriver den sida som visas.  Frn
    hjlpsidan kan man ven f upp en innehllsfrteckning ver all
    hjlp som finns att f.
    
    </dl>
     """),

    "text":

    ("Hjlp fr inlggsvisning", "Inlgg", """

    Den hr sidan visar ett inlgg.  Den frsta raden innehller
    tidpunkten nr inlgget skrevs (alla tidpunkten anges i
    LysKOM-serverns tidszon), inlggets textnummer, och namnet p
    frfattaren.  Om du klickar p frfattarens namn kommer du till en
    <a href="conf">statussida</a> som bland annat visar hans
    presentation.  Du kan ven skicka brev till honom frn den sidan.

    <p>Efter den frsta raden fljer en lista med alla mottagare till
    inlgget.  Ett inlgg kan ha bde mten och personer som
    mottagare.  Alla som r medlem i ngot av mtena kommer att f
    lsa inlgget automatiskt.  Om ngot av mtena r ett ppet mte
    kan dessutom vem som helst lsa texten om de lyckas fr reda p
    dess textnummer.  Om man klickar p en mottagares namn kommer man
    till samma <a href="conf">statussida</a> som nr man klickar p
    frfattarens namn.  Efter frfattarens namn str inom klamrar
    (&lt;&gt;) texten ordningsnummer i mtet.

    <p>Mottagarna kan vara antingen <i>mottagare</i> eller <i>extra
    kopiemottagare</i>.  Den enda skillnaden mellan de tv begreppen
    r hur systemet beter sig nr man kommenterar ett inlgg.  Ngot
    frenklat kan man sga att kopian kommer att skickas till alla
    mottagare, men inte till extra kopiemottagarna.  <a
    href="comment_recip_default">De exakta reglerna</a> r lite
    komplexare.
    
    <p>Om mottagaren r en person som har lst inlgget kommer en
    extra rad, som kan se ut som "Mottaget: 1996-08-24 05:16:09", att
    skjutas in.  Den visar nr personen lste inlgget.

    <p>Man kan lgga till en mottagare i till ett inlgg i efterhand.
    <!-- FIXME: not implemented --> Fr tillfllet mste man dock
    anvnda en annan klient n WWW-kom fr att gra det.  Mottagare
    som lagts till i efterhand markeras genom att de fr en extra rad
    som ser ut som "Snt: 1996-09-18 10:42:00".  Om det var ngon
    annan n frfattaren till inlgget som snde det till mtet skrivs
    dessutom raden "Snt av: <i>personnamn</i>" ut.

    <p>Efter mottagarna str det vilket inlgg detta inlgg r en
    kommentar eller fotnot till, om inlgget r en kommentar eller en
    fotnot.  Man kan klicka p textnumret fr att se den kommenterade
    texten.

    <p>Inlggets rende visas sist i huvudet.  Sedan fljer sjlva
    texten, och till sist visas om texten har ngra kommentarer eller
    fotnoter.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
     """),

    "conf":

    ("Hjlp fr textversikt", "Textversikt", """

    Den hr sidan visar vilka olsta texter du har i ett visst mte.
    Texterna visas i den ordning du kommer att f lsa dem om du
    anvnder dig av default-valet.  (Om du anvnder navigeringslist r
    det det val som finns lngst till vnster.  Om du anvnder den
    nyare layout som infrdes juli 1997 nr du defaultvalet genom
    pilen lngst upp till hger).  verst visas den ldsta
    texten.  Under den visas, indenterat, alla texter som r kommentar
    till den, med kommentarer till sig indenterade ytterligare ett
    steg, och s vidare.  Sedan kommer den ldsta texten som nnu inte
    skrivits ut.

    <p>P <a href="configuration">instllningssidan</a> kan du stlla
    in s att frfattarnamnen blir lnkar till <a href="conf"
    >statussidan</a> fr respektive frfattare.  Den finessen r
    normalt avslagen eftersom sidan ltt blir fr plottrig om lnkarna
    r p.

    <p>Om det finns fler n 40 olsta inlgg i mtet kommer enbart de
    frsta 40 inlggen att visas.  En textrad om att det finns fler
    olsta inlgg dyker i s fall upp lngst ner p sidan.  Grnsen
    kommer i framtiden att g att stlla in via instllningssidan.
    <!-- FIXME -->

    <p>Om det finns fler n 20 olsta inlgg i mtet kommer sidan att
    innehlla ett formulr dr du kan bestmma hur mnga inlgg du
    vill lsa.  Med hjlp av det kan du allts enkelt hoppa ver
    inlgg om det finns fler inlgg n du har tid att lsa.
    Grnsen kommer i framtiden att g att stlla in via
    instllningssidan.  <!-- FIXME -->

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
     """),

    "conf_stat":

    ("Hjlp fr statussidan", "Statussidan", """

    P statussidan kan du se statusen fr ett visst mte eller en viss
    person.  Om du r organisatr fr mtet eller personen kan du
    dessutom pverka mtet/personen.  Du kan dessutom g med i mten,
    skicka brev till mten, och en del annat.

    <p>Statussidan kommer inom kort att genomg en vlbehvlig
    ansiktslyftning.  Mer funktioner kommer att infras.  Nr det r
    klart kommer den hr hjlpsidan att bertta mer i detalj vad man
    kan gra och vad det innebr.  <!-- FIXME-->

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "write_text":

    ("Hjlp fr inlggsskrivning", "Skriva inlgg i mte", """

    Den hr sidan hamnar du p d du skriver inlgg i ett visst mte.

    <p><!-- FIXME -->Den hr hjlpsidan kommer att kompletteras
    senare.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),
    
    "comment":
    
    ("Hjlp fr kommentarsskrivning", "Att kommentera ett inlgg", """

    Den hr sidan hamnar du p d du kommenterar ett inlgg.

    <p><!-- FIXME -->Den hr hjlpsidan kommer att kompletteras
    senare.

    <p>Se ven:
    <ul>
    <li><a href="comment_recip_default">Vart skickas en kommentar?</a>
    <li><a href="answer">Personliga svar</a>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),
    
    "answer":
    
    ("Hjlp fr svarsskrivning", "Att svara p ett inlgg", """

    Den hr sidan hamnar du p d du svarar p ett inlgg.  Svaret
    kommer att hamna frfattarens och din brevlda.

    <p><!-- FIXME -->Den hr hjlpsidan kommer att kompletteras
    senare.

    <p>Se ven:
    <ul>
    <li><a href="comment">Att kommentera ett inlgg</a>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),
    
    "comment_recip_default":

    ("Vart skickas en kommentar?", "Vart skickas en kommentar?", """

    Nr du kommenterar en text r grundregeln att kommentarer hamnar i
    de mten och personer som r mottagare till inlgget du
    kommenterar.  Mten och personer som bara r extra kopiemottagare
    kommer inte att bli mottagare till det nya inlgget.

    <p>Fr varje mottagare kontrolleras dessutom om det r tilltet
    att skriva kommentarer i det mtet.  Om det inte r det snds
    inlgget i stllet till mtets <i>supermte</i>, om mtet har ett
    sdant.  Om mtet inte har ngot supermte kommer den mottagaren
    att ignoreras. (P <a href="conf">statussidan</a> kan man se om
    ett mte har ett supermte).  Det r tilltet att skriva
    kommentarer i de flesta mten, s fr det mesta pverkar det hr
    stycket inte vart texten skickas.

    <p>Sedan kontrolleras att du har rttighet att skriva i mtet.
    Fr att ha det mste du vara medlem i det mte som p statussidan
    kallas <i>tilltna frfattare</i>.  Om tilltna frfattare r satt
    till 0 innebr det att vem som helst fr skriva inlgg.  Om du
    inte har rtt att skriva i mtet skickas kommentaren till
    supermtet.  Den hr kontrollen upprepas tills man nr ett mte
    som du har rtt att skriva i, eller tills systemet trttnar p att
    leta upp nya supermten.  I de flesta mten fr vem som helst
    skriva inlgg, s fr det mesta pverkar det hr stycket inte vart
    texten skickas.
    
    <p>Till sist frsker systemet se till att bde du och frfattaren
    till det inlgg du kommenterar kommer att f lsa det inlgg du
    skriver och eventuella framtida kommentarer till det.  Det grs
    genom att ni bgge blir mottagare till inlgget om ni inte r
    medlem i ngot av de mten som redan r mottagare.

    <p>Alla dessa steg grs innan du fr upp formulret dr du skriver
    din kommentar.  P den sidan kan du sedan vlja bort mottagare.
    <!-- FIXME: rewrite when below is implemented --> I framtida
    versioner av WWW-kom kommer du ven att kunna lgga till nya
    mottagare dr.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="comment">Kommentera ett inlgg</a>
    </ul>
    """),

    "set_presentation":

    ("Hjlp fr presentationsndring", "ndra presentation", """

    <!-- FIXME-->Hjlptexten fr den hr sidan r inte klar n.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "kill":

    ("Hjlp fr avsluta", "Avsluta", """

    <!--FIXME-->Hjlptexten fr den hr sidan r inte klar n.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "who_is_on":

    ("Hjlp fr vilkalistan", "Vilkalistan", """

    Hr kan du se vilka som r inne i LysKOM just nu.  Fr varje
    person anges dessutom vilket mte han r nrvarande i just nu.

    <p>Siffran lngst till vnster r ett <i>sessionsnummer</i>.
    Varje ny uppkoppling till servern fr ett nytt lpnummer.

    <p>Den hr sidan kan ven visa enbart de som r nrvarande i ett
    visst mte.  I s fall str det "Nrvarande i mte" i stllet fr
    "Fljande personer r inloggade fr nrvarande".

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "select_conf_form":

    ("Hjlp fr mtesuppslagning", "Leta mte", """

    Den hr sidan kan du anvnda nr du vill gra ngot med ett mte
    eller en person som inte syns p <a
    href="home">mtesversikten</a>.  Den r anvndbar till exempel
    nr du vill skicka ett brev eller g med i ett mte.

    <p>Du fr fylla i namnet p mtet eller personen du vill gra
    ngot med.  Om skningen p namnet ger exakt en trff kommer du
    att hamna p <a href="conf">statussidan</a> fr det du skte.
    Annars fr du upp en sida som listar alla mten/personer som
    matchar skmnstret.

    <p>Matchningen grs ord fr ord.  Frst tas allt som str inom
    parenteser i mtesnamnen bort.  Sedan delas mtesnamnen upp i
    ord.  Drefter jmfrs varje ord med de ord du matat in.  Du kan
    utelmna bokstver i slutet p varje ord, och du kan utelmna ord
    i slutet p mtesnamnet.  Matchningen betraktar stora och sm
    bokstver som samma bokstav.

    <p>Ett exempel kanske frtydligar matchningen.  Skstrngen "k e"
    matchar till exempel "(Alla) KOM(-system) (-) Erfarenhetsutbyte",
    "Kampsport erfarenhetsutbyte" och "Kent Engstrm", men inte
    "Lysators KOM-system erfarenhetsutbyte", "Alla KOM-system
    Erfarenhetsutbyte", eller "Kampsport - erfarenhetsutbyte".

    <p>Du kan stlla in om du vill ska efter mten, personer eller
    bde och.

    <p>Se ven:
    <ul>
    <li><a href="conf">Statussidan</a>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "configuration":

    ("Hjlp fr instllningar", "Instllningar", """

    Du kan sjlv pverka hur WWW-kom fungerar.  Bland annat kan du
    vlja mellan olika utseenden p ikonerna, om du vill ha
    bakgrundsfrg eller inte, och hur mnga mten som ska visas p <a
    href="home">mtesversikten</a>.  Sidan innehller utfrliga
    frklaringar som frklarar vad varje parameter innebr.

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "create_conf_form":

    ("Hjlp fr mtesskapning", "Skapa mte", """

    Den hr sidan anvnds fr att skapa mten.  Du blir organisatr
    fr mten som du skapar.  Nr du har skapat mtet hamnar du p en
    statussida fr mtet.  Drifrn kan du skapa en presentation fr
    mtet, och du kan ven g med i mtet.

    <!-- FIXME: add more text here -->

    <p>Se ven:
    <ul>
    <li><a href="index">Innehllsfrteckning</a>
    <li><a href="toolbar">Navigeringslisten</a>
    </ul>
    """),

    "time":

    ("Hjlp fr se tiden", "Tiden", """

    Den hr sidan visar vad klockan r.  Den visar dels vad
    LysKOM-servern tycker klockan r, dels vad WWW-kom tycker klockan
    r.

    """),

    "index":

    # Keep this list in sync with testsuite/lm.3/README.
    ("Innehllsfrteckning", "Innehll", """

    Hjlp finns om fljande mnen:
    <ul>
    <li><a href="toolbar">Navigeringslisten</a>
    <li><a href="login">Inloggningsbilden</a>
    <li><a href="home">Mtesversikt -- vilka mten finns olsta texter i?</a>
    <li><a href="conf">Textversikt -- vad r olst inom ett mte?</a>
    <li><a href="text">Inlggsvisning</a>
    <li><a href="select_conf_form">Leta mte</a>
    <li><a href="conf_stat">Statussida fr mten/personer</a>
    <li><a href="write_text">Skriva inlgg</a>
    <li><a href="comment">Kommentera inlgg</a>
    <li><a href="answer">Svara personligt p inlgg</a>
    <li><a href="comment_recip_default">Vart hamnar kommentarer?</a>
    <li><a href="set_presentation">ndra presentation</a>
    <li><a href="create_conf_form">Skapa mte</a>
    <li><a href="kill">Avsluta</a>
    <li><a href="who_is_on">Vem r inloggad?</a>
    <li><a href="configuration">Instllningar</a>
    </ul>
    """)}



class sv_pages(pages):

    helpmap = SV_HELPMAP

    def stdfoot(self):
	return ("<hr noshade><table><tr><td>"
		+ komhtml.icon("wwwkom", "WWW-koms hemsida", "/")
		+ komhtml.icon("signum", "Signum Support AB",
			       "http://www.signum.se/")
		+ '</td><td><font size=-1>Sidan genererad '
		+ self.format_date(time.localtime(time.time()))
		+ ' av WWW-kom.</font><br>\n'
		+ 'WWW-kom. Copyright  1996 Signum Support AB.</td></tr></table>\n')

    def title(self, t):
	return "LysKOM: " + t

    def ambiguous_login(self, given, matches):
	res=["<ul>"]
	for m in matches:
	    res.append('<li>'
		       + komhtml.anchor(komhtml.komurl("login", m.conf_no()),
					komhtml.htmlquote(m.name())))
	res.append("</ul>\n")
	return self.page("Vem r du?", "Vem r du?",
			 "Det namn du angav, \"" + komhtml.htmlquote(given)
			 + "\", kan vara ngon av fljande personer:\n"
			 + string.joinfields(res, "\n"))

    def bad_password_for_session(self, given_user):
	return self.page("Fel lsen", "Felaktigt lsenord",
			 "Det lsenord du angav stmmer inte med "
			 + "lsenordet fr "
			 + given_user + '.  '
			 + komhtml.anchor(komhtml.komurl("login"),
					  "Frsk igen."))

    def nonexisting_person_url(self, given_number):
	return self.page("Felaktig URL", "Felaktig URL",
			 "Du har fljt en lnk som innehller en referens till"
			 + " person nummer " + `given_number`
			 + ". Det finns fr tillfllet ingen sdan anvndare. "
			 + komhtml.anchor(komhtml.komurl("login"),
					  "Frsk igen."))

    def noconnect(self):
	return self.page("Servern svarar inte", "LysKOM-servern svarar inte",
			 "LysKOM-servern kan inte ns.  Det kan bero p att "
			 + "servern r nere eller ngot ntverksproblem.  "
			 + "Frsk igen om en halvtimme.")

    def session_redirect(self, newurl):
	return self.page("Omstyrning", "Omstyrning",
			 "Din WWW-klient tycks inte frst felkod 301. Det "
			 + "innebr troligtvis att du inte kan anvnda den "
			 + "fr att lsa LysKOM med WWW-kom, men om du har "
			 + "tur kanske du kan anvnda WWW-kom genom att "
			 + komhtml.anchor(newurl, "flja denna lnk"))

    def who_is_on(self, wholist):
	header = "<table border=0 cellpadding=3>"
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Inloggade i lyskom",
			 "Fljande personer r inloggade fr nrvarande",
			 header + wholiststring + footer)

    def who_is_on_conf(self, conf, wholist):
	header = ("Fljande personer r just nu nrvarande i "
		  + conf + "\n\n<table border=0 cellpadding=3>")
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Nrvarande i mte",
			 "Nrvarande i mte",
			 header + wholiststring + footer)

    def not_present(self):
	return "Ej nrvarande i ngot mte"

    def format_footnote(self, footnote, footnote_author):
	return ("Fotnot i text " + footnote + " " + footnote_author
		+ "<br>\n")

    def format_comment(self, comment, comment_author):
	return ("Kommentar i text " + comment + " " + comment_author
		+ "<br>\n")

    def format_date(self, date):
	return "%04d-%02d-%02d %02d:%02d:%02d" % date[0:6]

    def format_date_sans_time(self, date):
	return "%04d-%02d-%02d" % date[0:3]

    def format_uplink(self, is_footnote, parent_text, parent_author_name,
		      sent_at, sender_name):
	if is_footnote:
	    res = "Fotnot till text "
	else:
	    res = "Kommentar till text "
	res = res + parent_text + " " + parent_author_name + "<br>\n"
	if sent_at:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_at)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def undef_conf(self, conf_no):
	return "Person/mte nummer " + `conf_no` + " (existerar ej/hemlig)"

    def nonexisting_text(self):
	return " (ej lsbar av dig)"

    def nonexisting_text_long(self):
	return "Texten finns inte, eller ocks r den hemlig."

    def anonymous_author(self):
	return " (anonym frfattare)"

    def nonexistent_author(self, pers_no):
	return " (utplnad/hemlig frfattare nummer " + `pers_no` + ")"

    def by_author(self, author):
	return "av " + author

    def format_recipient(self, is_carbon_copy, name, local_no,
			 rec_time, sent_time, sender_name):
	if is_carbon_copy:
	    res = "Extra kopiemottagare: "
	else:
	    res = "Mottagare: "
	res = res + name + " &lt;" + `local_no` + "&gt;<br>\n"
	if rec_time:
	    res = (res + "&nbsp;&nbsp;Mottaget: " + self.format_date(rec_time)
		   + "<br>\n")
	if sent_time:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_time)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def text_rewrite_map(self, map):
	if map["lines"] == 1:
	    map["lines"] = "1 rad"
	else:
	    map["lines"] = `map["lines"]` + " rader"
	marks = map["num_marks"]
	if marks == 0:
	    map["marks"] = ""
	elif marks == 1:
	    map["marks"] = "Markerad av en person<br>\n"
	else:
	    map["marks"] = "Markerad av " + `marks` + " personer<br>\n"

	# FIXME
	map["default_url"] = "<i>Default-URL</i>"


    def alt_conf(self):
	return "Olsta i mtet"

    def explain_conf(self):
	return "Lista olsta inlgg i mtet"

    def alt_comment(self):
	return "Kommentera"

    def explain_comment(self, textno):
	return "Skriv en kommentar till text " + `textno`

    def alt_answer(self):
	return "Besvara"

    def explain_answer(self, textno):
	return "Skriv en personlig kommentar till text " + `textno`

    def alt_write_text(self):
	return "Skriv inlgg"

    def explain_write_text(self):
	return "Skriv inlgg"

    def alt_review_text(self):
	return "terse inlgg"

    def explain_review_text(self):
	return "terse inlgg"

    def alt_help(self):
	return "Hjlp"

    def explain_help(self):
	return "Hjlp om denna sida"

    def alt_next_conf(self, cname):
	return "Nsta mte"

    def explain_next_conf(self, cname):
	return "G till nsta mte (" + cname + ")"

    def alt_see_time(self):
	return "Se tiden"

    def explain_see_time(self):
	return "Se tiden (enligt servern)"

    def alt_home(self):
	return "Hem"

    def explain_home(self):
	return "Lista mten med olsta texter"

    def alt_kill(self):
	return "Logga ut"

    def explain_kill(self):
	return "Avsluta WWW-kom"

    def alt_next_text(self, tno):
	return "Nsta text (" + `tno` + ")"

    def explain_next_text(self, tno):
	return "Lsa nsta text (" + `tno` + ")"

    def alt_unformatted(self):
	return "Lsa oformatterad"

    def explain_unformatted(self, tno):
	return "Lsa text " + `tno` + " igen, oformatterad"

    def alt_formatted(self):
	return "Lsa formatterad"

    def explain_formatted(self, tno):
	return "Lsa text " + `tno` + " igen, heuristiskt formatterad"

    def alt_config(self):
	return "ndra instllningar"

    def explain_config(self):
	return "Formulr fr att ndra personliga instllningar"

    def alt_create_conf(self):
	return "Skapa mte"

    def explain_create_conf(self):
	return "Formulr fr att skapa nytt mte"

    def alt_next_comment(self, tno):
	return "Nsta kommentar (" + `tno` + ")"

    def explain_next_comment(self, tno):
	return "Lsa nsta kommentar (" + `tno` + ")"

    def alt_next_footnote(self, tno):
	return "Nsta fotnot (" + `tno` + ")"

    def explain_next_footnote(self, tno):
	return "Lsa nsta fotnot (" + `tno` + ")"

    def alt_select_conf(self):
	return "Lista mten"

    def explain_select_conf(self):
	return "Sk efter mte och visa info"

    def text_format(self):
	if self.july_1997_layout:
	    return TEXT_FORMAT_JULY_1997
	else:
	    return TEXT_FORMAT
	    
    def format_text(self, map):
	self.text_rewrite_map(map)
	return self.text_format() % map

    def format_presentation(self, map, name_nolink):
	self.text_rewrite_map(map)
	return ("<p><b>Presentation fr mtet:</b>\n<p>"
		+ self.text_format() % map)

    def format_motd(self, map, name_nolink):
	self.text_rewrite_map(map)
	return ("<p>Lapp p drren fr " + name_nolink + ":<dl><dd>"
		+ self.text_format() % map + "</dl>")

    def info_unread_conf(self, conf, unread):
	if unread == 1:
	    return "1 olst i " + conf
	else:
	    return `unread` + " olsta i " + conf

    def there_are_more_unread_confs(self):
	return ("\n<p>\nDu har olsta inlgg i nnu fler mten. "
		+ "De kommer att visas nr du har lst ovanstende mten.")

    def login(self, unreadlist, trunc_msg, tot_unread, is_login):
	if trunc_msg == "" and len(unreadlist) > 0:
	    if tot_unread == 1:
		trunc_msg = "\n\n<p>Du har totalt 1 olst text."
	    else:
		trunc_msg = ("\n\n<p>Du har totalt " + `tot_unread`
			     + " olsta texter.")

	if len(unreadlist) > 0:
	    msg = "Du har olsta inlgg i fljande mten:\n<p>\n" + unreadlist
	else:
	    msg = "Du har fr nrvarande inga olsta texter."

	if is_login:
	    return self.page("Vlkommen", "Vlkommen till LysKOM!",
			     "Du r nu inloggad. " + msg + trunc_msg)
	else:
	    return self.page("Olsta mten", "Olsta mten",
			     msg + trunc_msg)

    def text_link(self, text, creation_time, subject, prev_subject, author):
	if subject == prev_subject:
	    subject = "--"
	elif subject == "":
	    subject = "(rende saknas)"
	else:
	    subject = "<b>" + subject + "</b>"

	linktext = "%s (text %d)" % (subject, text)
	return "%s %s %s" % (self.format_date_sans_time(creation_time),
			     komhtml.text_as_link(text, linktext),
			     author)

    def different_passwords(self):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "Du angav tv olika lsenord.  Frsk igen.")

    def person_creation_failed(self, name):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "En person med namnet " +name+ " kunde inte skapas.\n"
			 + "Kanske finns det redan ngon som heter s?\n\n"
			 + "<p>Frsk igen med ett annat namn.\n"
			 + "Du kan till exempel lgga till en initial "
			 + "eller namnet p din organisation.")

    def creation_done(self, name, pno):
	return self.page("WWW-kom", "Vlkommen",
			 "Vlkommen till LysKOM, " + komhtml.htmlquote(name)
			 + "!\nHoppas du ska trivas hr.\n"
			 + "Nu mste du "
			 + komhtml.anchor(komhtml.komurl("login"), "logga in")
			 + ". "
			 + "Din Web-klient kommer att be dig mata in det namn "
			 + "och lsenord som du just angav.\n"
			 + "(Du tycker kanske att det r dumt att du ska "
			 + "behva mata in de uppgifterna igen.  Tyvrr "
			 + "tvingar HTTP fram den hr lsningen).\n\n"
			 + "<p>Om du r den sifferlskande typen vill du "
			 + "kanske veta att ditt anvndarnummer r " + `pno`
			 + ".  Annars kan du strunta i det -- du kan alltid "
			 + "anvnda ditt namn och behver inte komma ihg det "
			 + "nummer som anvnds internt i LysKOM-systemet.")

    def creation_done_sc(self, name, pno):
	return self.page("WWW-kom", "Vlkommen",
			 "Du har nu skapat anvndaren "
			 + komhtml.htmlquote(name) + ".")

    def button_submit_text(self, presentations, footnotes, comments):
	if presentations > 0:
	    return "Skapa presentationen"
	elif footnotes > 0:
	    return "Skapa fotnoten"
	elif comments > 0:
	    return "Skapa kommentaren"
	else:
	    return "Skapa texten"

    def write_text_form(self, map):
	return WRITE_TEXT_FORM % map

    def write_comment(self, form, parent, parent_author):
	return self.page("Kommentera text " + parent,
			 "Kommentera text " + parent,
			 WRITE_COMMENT_FORMAT % {"parent_link": parent,
						 "parent_author":parent_author,
						 "form": form})
    def cannot_answer_anonymous(self):
	return self.page("Personligt svar", "Kan ej skapa personligt svar",
			 """Den text du kommenterar r anonym.  Det
			 finns inget stt att f reda p vem som
			 skrivit den.  Det gr att du tyvrr inte kan
			 svara p den med ett personligt svar.
			 """)

    def cannot_answer_dead(self):
	return self.page("Personligt svar", "Kan ej skapa personligt svar",
			 """Den text du kommenterar r skriven av en
			 frfattare som inte lngre existerar.
			 Det gr att du tyvrr inte kan svara p den
			 med ett personligt svar.
			 """)

    def write_personal_answer(self, form, parent, parent_author):
	return self.page("Svara p text " + parent,
			 "Svara p text " + parent,
			 WRITE_PERSONAL_ANSWER_FORMAT %
			 {"parent_link": parent,
			  "parent_author": parent_author,
			  "form": form})

    def review_texts(self):
	return self.page("terse lsta texter", 
			 "terse lsta texter", REVIEW_TEXTS_FORM)

    def write_text(self, form, conference):
	return self.page("Skriva inlgg",
			 "Skriva inlgg i " + conference,
			 WRITE_TEXT_FORMAT % {"conf-name": conference,
					      "form": form})

    def write_presentation(self, form, conference):
	return self.page("Presentera " + conference,
			 "Skriva presentation fr " + conference,
			 WRITE_PRESENTATION_FORMAT % {"conf-name": conference,
						      "form": form})

    def conversion_format(self, map):
	return CONVERSION_FORMAT % map

    def write_text_format_recipient(self, conf, conf_as_link):
	return ('Mottagare: <input type="checkbox" name="rcpt'
		+ '" value="' + `conf` + '" checked> '
		+ conf_as_link + '<br>\n')

    def write_text_format_cc_recipient(self, conf, conf_as_link):
	return ('Extra kopie-mottagare: <input type="checkbox" name="cc_rcpt'
		+ '" value="' + `conf` + '" checked> '
		+ conf_as_link + '<br>\n')

    def write_text_format_recipient_part(self, recips):
	if len(recips) == 0:
	    return ""
	elif len(recips) == 1:
	    return recips[0]
	else:
	    return ("Texten du skriver har flera mottagare. "
		    + "Du kan ta bort mottagare genom att vlja bort dem."
		    + "<br>\n"
		    + string.joinfields(recips, ""))

    def write_text_format_comment(self, text, author):
	return ('<input type="checkbox" name="parent" value="'
		+ `text` + '" checked> Kommentar till text ' + `text`
		+ ' ' + author + '<br>\n')

    def write_text_format_footnote(self, text, author):
	return ('<input type="checkbox" name="parent_footnote" value="'
		+ `text` + '" checked> Fotnot till text ' + `text`
		+ ' ' + author + '<br>\n')

    def write_text_comment_ref_form(self, body):
	return COMMENTING_FORM % {"lead": "Du kommenterar denna text:",
				  "body": komhtml.htmlquote(body)}

    def write_text_footnote_ref_form(self, body):
	return COMMENTING_FORM % {"lead": "Du skriver en fotnot till:",
				  "body": komhtml.htmlquote(body)}

    def write_text_format_comments_part(self, comments):
	if len(comments) == 0:
	    return ""
	elif len(comments) == 1:
	    return comments[0]
	else:
	    return ("Texten du skriver r kommentar till flera texter. "
		    + "Du kan vlja bort en eller flera av dem.<br>"
		    + string.joinfields(comments, ""))

    def write_text_format_presentation(self, cno, cname):
	return ('<input type="checkbox" name="presentation_for" value="'
		+ `cno` + '" checked> Presentation fr ' + cname + '<br>\n')

    def write_text_format_presentations_part(self, presents):
	if len(presents) == 0:
	    return ""
	elif len(presents) == 1:
	    return presents[0]
	else:
	    return ("Texten du skriver r presentation till flera mten. "
		    + "Det r nog ovanligt att det r vettigt att ha samma "
		    + "text som presentation till flera mten -- du har vl "
		    + "koll p vad du gr nu? "
		    + "Du kan vlja bort en eller flera av dem.<br>"
		    + string.joinfields(presents, ""))
	

    def new_texts_exists(self, new_texts, form):
	new_texts = string.join(new_texts, "\n<hr>\n")
	return self.page("Nya kommentarer", "Nya kommentarer funna",
			 WRITE_TEXT_NEW_COMMENTS % {"new_texts": new_texts,
						    "form": form})

    #
    # ----------------------------------------------------------------
    #

    def link_move_text(self):
	return "Flytta"

    def move_text(self, map):
	return self.page("Flytta text", "", MOVE_TEXT_FORM % map)

    def move_text_completed(self, map):
	return self.page("Flytta text klart", "", 
			 """
Text nummer %(text-no)s r nu flyttad.

%(next-action)s

""" % map)

    #
    # ----------------------------------------------------------------
    #

    def killed(self):
	return self.page("Omstart", "Omstart", KILLED)

    def select_conf_form(self):
	return self.page("Lista mten", "Lista mten", SELECT_CONF_FORM)

    def list_conf(self, matches):
	res="<ul>\n"
	for item in matches:
	    res = (res + '<li>'
		   + komhtml.conf_as_link(item.conf_no(), item.name())
		   + '\n')
	res = res + "</ul>\n\n"
	return self.page("Mten / Personer", "Mten / Personer",
			 "Fljande mten/personer stmmer in p det du skte: <p>" 
			 + res)

    def conf(self, session, cno, name_link, name_nolink, unread_list, truncated, unread, estim):

	map = {}

	if len(unread_list) == 0:
	    if cno == 6 and name_nolink == "Inlgg }t mig":
		map["unread"] = "Du har inga olsta texter i Mtet."
	    else:
		map["unread"] = "Du har inga olsta texter i mtet."
	    map["estim-unread"] = "" 
	else:
	    map["unread"] = "Dessa texter r olsta:" + string.joinfields(
		unread_list, "\n")
	    if estim == 1:
		map["estim-unread"] = "Du har totalt 1 olst text.\n<p>"
	    else:
		map["estim-unread"] = ("Du har totalt " + `estim`
				       + " olsta.\n<p>")

	if unread:
	    map["set-unread-form"] = SET_UNREAD_FORM % \
				     {"name_nolink":name_nolink,
				     "conf_no":cno}
	else:
	    map["set-unread-form"] = ""

	if truncated:
	    map["truncated"] = "Du har nnu fler olsta texter."
	else:
	    map["truncated"] = ""

	return lingo.page("Olsta i " + name_nolink,
			  "Olsta i " + name_link,
			  CONF % map)

    def conf_stat(self, in_map, currently_member, is_supervisor, conf):
	csmap = {}
	if not currently_member:
	    if in_map["join_allowed"]:
		csmap["become-member"] = komhtml.form_anchor(
		    in_map["join"], "G med i mtet") + "<br>"
	    else:
		# FIXME: send I-wanna-be-a-member-of-your-cool-conf
		# to the organizer.
		if conf.type().is_letterbox():
		    csmap["become-member"] = ""
		else:
		    csmap["become-member"] = """

		    Du fr inte g med i mtet.  Skicka ett brev till
		    organisatren fr medlemsskap.
		    """
	    csmap["disjoin-conference"] = ""
	    csmap["goto-conference"] = ""
	    csmap["set-unread-form"] = ""
	    csmap["estimated-unread"] = ""
	else:
	    csmap["become-member"] = ""
	    csmap["disjoin-conference"] = komhtml.form_anchor(
		in_map["disjoin"], "Uttrda ur mtet") + "<br>"
	    csmap["goto-conference"] = (komhtml.anchor(in_map["goto"],
						       "G till mtet")
					+ "<br>")
	    csmap["set-unread-form"] = SET_UNREAD_FORM % \
				       {"name_nolink":in_map["name_nolink"],
					"conf_no":in_map["conf_no"]}

	    if in_map["estimated"] == 0:
		csmap["estimated-unread"] = "Du har inga olsta i mtet."
	    elif in_map["estimated"] == 1:
		csmap["estimated-unread"] = "Du har 1 olst inlgg i mtet."
	    else:
		csmap["estimated-unread"] = ("Du har "
					     + `in_map["estimated"]`
					     + " olsta inlgg i mtet.")

	csmap["motd"] = in_map["motd"]
	if in_map["presentation"] == None:
	    if conf.type().is_letterbox():
		csmap["presentation"] = "Personen saknar presentation."
	    else:
		csmap["presentation"] = "Mtet saknar presentation."
	else:
	    csmap["presentation"] = in_map["presentation"]
	
	if is_supervisor:
	    csmap["change-presentation"] = in_map["change-presentation"]
	else:
	    csmap["change-presentation"] = ""

	info = ["<b>vrig information:</b><br><table>"]

	if conf.type().is_letterbox():
	    crea = "Personen skapad"
	    secr = "Personen r hemlig"
	    prot = None
	    unprot = ("Personen r ppen"
		      +" (vem som helst fr bli medlem i brevldan)")
	else:
	    crea = "Mtet skapat"
	    secr = "Mtet r hemligt"
	    prot = "Mtet r skyddat (vem som helst fr ej bli medlem)"
	    unprot = None

	if in_map["creator"] != None:
	    info.append("<tr><td valign=top>" + crea + " av:</td><td valign=top>" + in_map["creator"] + "</td></tr>")
	info.append("<tr><td valign=top>" + crea + ":</td><td valign=top>" + self.format_date(conf.creation_time()) + "</td></tr>")
	# FIXME: Fortstt hr
	if conf.type().is_secret():
	    info.append("<tr><td colspan=2" + secr + "</td></tr>")
	if conf.type().is_protected():
	    if prot:
		info.append("<tr><td colspan=2" + prot + "</td></tr>")
	else:
	    if unprot:
		info.append("<tr><td colspan=2" + unprot + "</td></tr>")
	if conf.type().is_original():
	    info.append("<tr><td colspan=2" + "Kommentarer styrs om till supermtet" + "</td></tr>")

	if in_map["supervisor"] == None:
	    info.append("<tr><td colspan=2" + "Organisatr saknas" + "</td></tr>")
	else:
	    info.append("<tr><td valign=top>Organisatr:</td><td valign=top>" + in_map["supervisor"] + "</td></tr>")

	if in_map["permitted_submitters"] == None:
	    info.append("<tr><td valign=top>Tilltna frfattare:</td><td valign=top>alla</td></tr>")
	else:
	    info.append("<tr><td valign=top>Tilltna frfattare:</td><td valign=top>"
			+ in_map["permitted_submitters"] + "</td></tr>")

	if in_map["super-conf"] == None:
	    info.append("<tr><td colspan=2" + "Supermte saknas" + "</td></tr>")
	else:
	    info.append("<tr><td valign=top>Supermte:</td><td valign=top>"
			+ in_map["super-conf"] + "</td></tr>")

	info.append("<tr><td valign=top>Antal medlemmar:</td><td valign=top>"
		    + `conf.no_of_members()` + "</td></tr>")
	info.append("<tr><td valign=top>Livslngd p inlgg:</td><td valign=top>"
		    + `conf.nice()` + " dagar" + "</td></tr>")
	info.append("<tr><td valign=top>Senaste inlgg:</td><td valign=top>"
		    + self.format_date(conf.last_written()) + "</td></tr>")

	# Don't include first_local_no or no_of_texts for now.

	csmap["info-fields"] = string.joinfields(info, "\n") + "\n</table>"

	return self.page("Status fr " + in_map["name_nolink"],
			 in_map["name_nolink"],
			 CONF_STAT % csmap)

    def create_presentation(self, url):
	return komhtml.anchor(url, "Skapa presentation")

    def change_presentation(self, url):
	return komhtml.anchor(url, "ndra presentationen")

    #
    # ----------------------------------------------------------------
    #                    Create conference
    # ----------------------------------------------------------------
    #

    def create_conf(self):
	return self.page("Skapa mte", "Skapa nytt mte", CREATE_CONF_FORM)

    def create_conf_empty_name(self):
	return self.page("Skapa mte misslyckades",
			 "Skapa mte misslyckades",
			 """Mtet kunde inte skapas, eftersom du inte
			 angav ngot namn p mtet.  Fyll i
			 namnfltet och frsk igen. 
			 """)

    def create_conf_long_name(self):
	return self.page("Skapa mte misslyckades",
			 "Skapa mte misslyckades",
			 """Mtet kunde inte skapas, eftersom det namn
			 du gett mtet inte godkndes.  Det r fr lngt.
			 """)

    def create_conf_bad_name(self):
	return self.page("Skapa mte misslyckades",
			 "Skapa mte misslyckades",
			 """Mtet kunde inte skapas, eftersom det namn
			 du gett mtet inte godkndes.  Det innehller
			 otilltna tecken.
			 """)

    def create_conf_conf_exists(self):
	return self.page("Skapa mte misslyckades",
			 "Skapa mte misslyckades",
			 """Mtet kunde inte skapas, eftersom det
			 redan finns ett mte med samma namn.
			 """)

    def create_conf_secret_public(self):
	return self.page("Skapa mte misslyckades",
			 "Skapa mte misslyckades",
			 """Mtet kunde inte skapas, eftersom du
			 frskt gra det bde hemligt och ppet.  Den
			 kombinationen accepteras inte av systemet.
			 """)

    #
    # ----------------------------------------------------------------
    #                    Administrate conference
    # ----------------------------------------------------------------
    #

    def alt_admin_conf(self):
	return "Administrera mte"

    def explain_admin_conf(self):
	return "Formulr fr att administrera ett mte"

    def admin_conf(self, map):
	return self.page("Administrera mte", "", ADMIN_CONF_FORM % map)

    def submit_admin_members(self, map):
	return self.page("Administrera medlemmar", "", 
			 SUBMIT_ADMIN_MEMBERS_FORM % map)

    #
    # ----------------------------------------------------------------
    #                    Create a new user
    # ----------------------------------------------------------------
    #

    def alt_create_user(self):
	return "Lgg till anvndare"

    def explain_create_user(self):
	return "Formulr fr att lgga till en ny anvndare"

    def create_user(self):
	return self.page("Lgga till ny anvndare", 
			 "Lgga till ny anvndare", CREATE_USER_FORM)

    #
    # ----------------------------------------------------------------
    #

    def time(self, server_time, local_time):
	return self.page("Se tiden", "Tiden",
			 "Klockan r just nu:\n<ul>\n<li>"
			 + self.format_date(server_time)
			 + " (enligt LysKOM-servern)\n<li>"
			 + self.format_date(local_time)
			 + " (enligt WWW-kom-servern)\n</ul>\n")

    def configuration(self, map):
	return self.page("ndra instllningar", "ndra instllningar",
			 CONFIGURATION_FORM % map)

lingo=sv_pages()
